//cyc's hoehoe routine
//	for the Weakest Othello League
//uhi:D

#ifndef HEADER_CYC
#define HEADER_CYC

#include "othello.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define CYCDEBUG 0

//nazo macro

#define CYC_TABLE_SIZE 91
#define cyc_tbl(x, y) ((y)*8 + (x))
#define cyc_tblx(pos) ((pos)%8)
#define cyc_tbly(pos) ((pos)/8)

#define CYC_MY 1
#define CYC_OP 2

// for debug
#if CYCDEBUG
#define C_PRINTF(a) printf a
#else
#define C_PRINTF(a)
#endif

static const int cyc_PT[] = {10,3,3,1,1,3,3,10};

static const int cyc_PP[]
={ 40 , 4 , 10 , 6 , 6 , 10 , 4 , 40 ,
   4  , 6 , 8  , 8 , 8 , 8  , 6 ,  4 ,
   10 , 8 , 3  , 3 , 3 , 3  , 8 , 10 ,
   6  , 8 , 3  , 0 , 0 , 3  , 8 ,  6 ,
   6  , 8 , 3  , 0 , 0 , 3  , 8 ,  6 ,
   10 , 8 , 3  , 3 , 3 , 3  , 8 , 10 ,
   4  , 6 , 8  , 8 , 8 , 8  , 6 ,  4 ,
   40 , 4 , 10 , 6 , 6 , 10 , 4 , 40 };
   
   
/*
static
int
centerPoint (int src)
{
	return cyc_PT[src];
}
*/

static
int
positionPoint (int src)
{
	return cyc_PP[src];
}

extern "C"
int				//NextPoint
cyc
(char	*board,	//board
 int	status)	//status (norm,passp,initp)
{
	if(passp(status) || initp(status))
		return 0;

	int mPoint=0;
	int mMinPoint=0;
	int mNextPoint=0;
	
	for (int i=0;i<64;i++)
	{
		int mGetPoint=Put(board,i,MY_COLOR,NOT_CHANGE);
		if ( mGetPoint>0 )
		{
			int mX1=cyc_tblx(i);
			int mY1=cyc_tbly(i);
			//int mXP=centerPoint(mX1);
			//int mYP=centerPoint(mY1);
			int mP=positionPoint(i);

			mPoint=0;
			
			for (int j=0;j<64;j++)
			{
				int mTmpPoint=0;
				int mX2=cyc_tblx(j);
				int mY2=cyc_tbly(j);

				int mX3=abs(mX1-mX2);
				int mY3=abs(mY1-mY2);

				if (board[j]==CYC_MY)
					mTmpPoint+=(mX3*mX3+mY3*mY3)/4;
				mPoint+=mTmpPoint;
			}
			
			mPoint+=mP*mP*mP+1;

			mPoint*=mGetPoint*mGetPoint;

			if (mMinPoint==0)
			{
				mMinPoint=mPoint;
				mNextPoint=i;
				C_PRINTF(("Start\n"));
				C_PRINTF(("Check:%d,%d ->Min:%d Get:%d mP:%d\n",cyc_tblx(mNextPoint),cyc_tbly(mNextPoint),mMinPoint,mGetPoint,mP));
			}
			else
			{
				if (mPoint<mMinPoint)
				{
					mMinPoint=mPoint;
					mNextPoint=i;
					C_PRINTF(("Check:%d,%d ->Min:%d Get:%d mP:%d\n",cyc_tblx(mNextPoint),cyc_tbly(mNextPoint),mMinPoint,mGetPoint,mP));
				}
			}
		}
	}
	
	C_PRINTF(("Go:%d,%d\n",cyc_tblx(mNextPoint),cyc_tbly(mNextPoint)));
	if (mMinPoint==0) return (-1);
	return mNextPoint;
}

#endif //#define HEADER_CYC
