/* othello.h Ver. 1.02 Written by gel(Hideo KIHARA) */

#ifndef __OTHELLO_H__
#define __OTHELLO_H__

#define SPACE 0
#define BLACK 1
#define WHITE 2

#define MY_COLOR 1
#define OP_COLOR 2

#define CHANGE 1
#define NOT_CHANGE 0
#define R_CHANGE -1

#define INIT_AS_BLACK -2
#define INIT_AS_WHITE -1
#define NORM 0
#define PASS 1

#define REVERSE 1

#define SILENT      001
#define INTERACTIVE 002
#define LEAGUE      004
#define HELP        010
#define LOG         020

#define passp(s) ((s == PASS))
#define initp(s) (((s == INIT_AS_BLACK) || (s == INIT_AS_WHITE)))

#define silentp(mode) ((mode) & SILENT)
#define itractp(mode) ((mode) & INTERACTIVE)
#define leaguep(mode) ((mode) & LEAGUE)
#define helpp(mode) ((mode) & HELP)
#define logp(mode) ((mode) & LOG)

/* for compatibility */
#define CountStones CountDisks

typedef int participant_t(char *board, int status);

typedef struct entry{
  participant_t *func;
  char *name;
  char *Lname;
} Entry;


#ifdef __cplusplus /* added by Tak. */
extern "C" {
#endif

extern int Put(char *board, int place, int color, int flag);
/* ֤:placeˤˤҤä֤Ŀ (placeΤϴޤޤʤ) */
/* place:0..63 */
/* color place֤ (MY_COL,OP_COL 侩) */
/* flag  CHANGE:̤򹹿 NOT_CHANGE:̤򹹿ʤ */
extern void CountDisks(char *board, int *my_c, int *op_c);
/* my_c:ʬζο op_c:ζο */
extern void Reverse(char *board);
/* MY_COL  OP_COL 촹() */
extern void CopyBoard(char *src_b, char *dst_b, int reversep);
/* ̤Υԡ */
/* src_b:ԡ dst_b:ԡ */
/* reversep NORM:Τޤޥԡ REVERSE:MY_COLOP_COL촹ƥԡ */
extern long GetTime(void);
/* ׹ͻ֤μ */
/* ñ̤ms */
extern int LastHand(void);
/* ľμ֤-1λϥѥ1ܤλ */

#ifdef __cplusplus
}	// extern "C"
#endif

extern const int direction_x[];
extern const int direction_y[];
extern const int direction[];

extern Entry e_list[];

#endif

